﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{
			
				public static int ADD_HL_R16( Processor Processor, Opcode Opcode )
				{
					ushort RegisterValue = Processor.RegisterPairArray[((Opcode.Value>>4)&0x03)].Value;
					ushort Temp = (ushort)( Processor.HL + RegisterValue );
					Processor.NegativeFlag = false;
					Processor.HalfCarryFlag = ( ( ( Processor.HL ^ RegisterValue ^ Temp ) & 0x1000 ) != 0 );
					Processor.CarryFlag = ( ( ( ((int)Processor.HL) + ((int)RegisterValue) ) & 0x10000 ) != 0 );
					Processor.HL = Temp;
					return 0;
				}
				
				public static int ADD_SP_N8( Processor Processor, Opcode Opcode )
				{
					sbyte Offset = Processor.Memory.ReadS8( Processor.PC++ );
					ushort Temp = (ushort)( Processor.SP + Offset );
					Processor.ClearFlags();
					if( Offset >= 0 )
					{
						Processor.CarryFlag = ( Processor.SP > Temp );
					}
					else
					{
						Processor.CarryFlag = ( Processor.SP < Temp );
					}
					Processor.HalfCarryFlag = ( ( ( Processor.SP ^ Offset ^ Temp ) & 0x1000 ) != 0 );
					Processor.SP = Temp;	
					return 0;
				}
				
				public static int DEC16( Processor Processor, Opcode Opcode )
				{
					Processor.RegisterPairArray[((Opcode.Value>>4)&0x03)].Value--;
					return 0;			
				}
				
				public static int INC16( Processor Processor, Opcode Opcode )
				{
					Processor.RegisterPairArray[((Opcode.Value>>4)&0x03)].Value++;
					return 0;			
				}
				
			}
			
		}
		
	}
	
}
	
