﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{
			
				public static int LD_HL_SPN8( Processor Processor, Opcode Opcode )
				{
					sbyte Offset = Processor.Memory.ReadS8( Processor.PC++ );
					ushort Temp = (ushort)( Processor.SP + Offset );
					Processor.ClearFlags();
					if( Offset >= 0 )
					{
						Processor.CarryFlag = ( Processor.SP > Temp );
					}
					else
					{
						Processor.CarryFlag = ( Processor.SP < Temp );
					}
					Processor.HalfCarryFlag = ( ( ( Processor.SP ^ Offset ^ Temp ) & 0x1000 ) != 0 );
					Processor.HL = Temp;	
					return 0;
				}
				
				public static int LD_mN16_SP( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU16( Processor.Memory.ReadU16( Processor.PC ), Processor.SP );
					Processor.PC += 2;
					return 0;
				}
				
				public static int LD_PC_HL( Processor Processor, Opcode Opcode )
				{
					Processor.PC = Processor.HL;
					return 0;
				}
				
				public static int LD_R16_N16( Processor Processor, Opcode Opcode )
				{
					Processor.RegisterPairArray[((Opcode.Value>>4)&0x03)].Value = Processor.Memory.ReadU16( Processor.PC );
					Processor.PC += 2;
					return 0;
				}
				
				public static int LD_SP_HL( Processor Processor, Opcode Opcode )
				{
					Processor.SP = Processor.HL;
					return 0;
				}
				
				public static int POP( Processor Processor, Opcode Opcode )
				{
					int RegisterIndex = ( ( Opcode.Value >> 4 ) & 0x03 );
					if( RegisterIndex >= 3 )
					{
						RegisterIndex++;
					}
					Processor.RegisterPairArray[RegisterIndex].Value = Processor.Memory.ReadU16( Processor.SP );
					Processor.SP += 2;
					return 0;
				}
				
				public static int PUSH( Processor Processor, Opcode Opcode )
				{
					int RegisterIndex = ( ( Opcode.Value >> 4 ) & 0x03 );
					if( RegisterIndex >= 3 )
					{
						RegisterIndex++;
					}
					Processor.SP -= 2;
					Processor.Memory.WriteU16( Processor.SP, Processor.RegisterPairArray[RegisterIndex].Value );
					return 0;
				}
				
			}
			
		}
		
	}
	
}
