﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{
			
				public static int CALL( Processor Processor, Opcode Opcode )
				{
					Processor.SP -= 2;
					Processor.Memory.WriteU16( Processor.SP, (ushort)( Processor.PC + 2 ) );
					Processor.PC = Processor.Memory.ReadU16( Processor.PC );
					return 0;
				}
				
				public static int CALL_CC( Processor Processor, Opcode Opcode )
				{
					ushort Address = Processor.Memory.ReadU16( Processor.PC );
					Processor.PC += 2;
					switch( (Conditions)( ( Opcode.Value >> 3 ) & 0x03 ) )
					{
						case Conditions.NZ:
							if( Processor.ZeroFlag == true )
							{
								return 0;
							}
							break;
						case Conditions.Z:
							if( Processor.ZeroFlag == false )
							{
								return 0;
							}
							break;
						case Conditions.NC:
							if( Processor.CarryFlag == true )
							{
								return 0;
							}
							break;
						case Conditions.C:
							if( Processor.CarryFlag == false )
							{
								return 0;
							}
							break;
					}
					Processor.SP -= 2;
	   				Processor.Memory.WriteU16( Processor.SP, Processor.PC );
					Processor.PC = Address;		
					return 7;
				}
				
				public static int RET( Processor Processor, Opcode Opcode )
				{
					Processor.PC = Processor.Memory.ReadU16( Processor.SP );
					Processor.SP += 2;
					return 0;
				}
				
				public static int RET_CC( Processor Processor, Opcode Opcode )
				{
					switch( (Conditions)( ( Opcode.Value >> 3 ) & 0x03 ) )
					{
						case Conditions.NZ:
							if( Processor.ZeroFlag == true )
							{
								return 0;
							}
							break;
						case Conditions.Z:
							if( Processor.ZeroFlag == false )
							{
								return 0;
							}
							break;
						case Conditions.NC:
							if( Processor.CarryFlag == true )
							{
								return 0;
							}
							break;
						case Conditions.C:
							if( Processor.CarryFlag == false )
							{
								return 0;
							}
							break;
					}
					Processor.PC = Processor.Memory.ReadU16( Processor.SP );
					Processor.SP += 2;
					return 6;
				}
				
				public static int RETI( Processor Processor, Opcode Opcode )
				{
					Processor.PC = Processor.Memory.ReadU16( Processor.SP );
					Processor.SP += 2;
					Processor.IFF |= 0x01;
					//Processor.IME = true;
					return 0;
				}
				
				public static int RST( Processor Processor, Opcode Opcode )
				{
					Processor.SP -= 2;
	   				Processor.Memory.WriteU16( Processor.SP, Processor.PC );
	   				Processor.PC = (ushort)( Opcode.Value & 0x38 );
	   				return 0;
				}
				
			}
			
		}
		
	}
	
}
