﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{

				public static readonly Opcode[] TableCB = new Opcode[]
				{
					new Opcode( 0xCB00, RLC, 8, "RLC %r0" ),
					new Opcode( 0xCB01, RLC, 8, "RLC %r0" ),
					new Opcode( 0xCB02, RLC, 8, "RLC %r0" ),
					new Opcode( 0xCB03, RLC, 8, "RLC %r0" ),
					new Opcode( 0xCB04, RLC, 8, "RLC %r0" ),
					new Opcode( 0xCB05, RLC, 8, "RLC %r0" ),
					new Opcode( 0xCB06, RLC, 15, "RLC (HL)" ),
					new Opcode( 0xCB07, RLC, 8, "RLC %r0" ),		
					new Opcode( 0xCB08, RRC, 8, "RRC %r0" ),
					new Opcode( 0xCB09, RRC, 8, "RRC %r0" ),
					new Opcode( 0xCB0A, RRC, 8, "RRC %r0" ),
					new Opcode( 0xCB0B, RRC, 8, "RRC %r0" ),
					new Opcode( 0xCB0C, RRC, 8, "RRC %r0" ),
					new Opcode( 0xCB0D, RRC, 8, "RRC %r0" ),
					new Opcode( 0xCB0E, RRC, 15, "RRC (HL)" ),
					new Opcode( 0xCB0F, RRC, 8, "RRC %r0" ),		
					new Opcode( 0xCB10, RL, 8, "RL %r0" ),
					new Opcode( 0xCB11, RL, 8, "RL %r0" ),
					new Opcode( 0xCB12, RL, 8, "RL %r0" ),
					new Opcode( 0xCB13, RL, 8, "RL %r0" ),
					new Opcode( 0xCB14, RL, 8, "RL %r0" ),
					new Opcode( 0xCB15, RL, 8, "RL %r0" ),
					new Opcode( 0xCB16, RL, 15, "RL (HL)" ),
					new Opcode( 0xCB17, RL, 8, "RL %r0" ),		
					new Opcode( 0xCB18, RR, 8, "RR %r0" ),
					new Opcode( 0xCB19, RR, 8, "RR %r0" ),
					new Opcode( 0xCB1A, RR, 8, "RR %r0" ),
					new Opcode( 0xCB1B, RR, 8, "RR %r0" ),
					new Opcode( 0xCB1C, RR, 8, "RR %r0" ),
					new Opcode( 0xCB1D, RR, 8, "RR %r0" ),
					new Opcode( 0xCB1E, RR, 15, "RR (HL)" ),
					new Opcode( 0xCB1F, RR, 8, "RR %r0" ),		
					new Opcode( 0xCB20, SLA, 8, "SLA %r0" ),
					new Opcode( 0xCB21, SLA, 8, "SLA %r0" ),
					new Opcode( 0xCB22, SLA, 8, "SLA %r0" ),
					new Opcode( 0xCB23, SLA, 8, "SLA %r0" ),
					new Opcode( 0xCB24, SLA, 8, "SLA %r0" ),
					new Opcode( 0xCB25, SLA, 8, "SLA %r0" ),
					new Opcode( 0xCB26, SLA, 15, "SLA (HL)" ),
					new Opcode( 0xCB27, SLA, 8, "SLA %r0" ),
					new Opcode( 0xCB28, SRA, 8, "SRA %r0" ),
					new Opcode( 0xCB29, SRA, 8, "SRA %r0" ),
					new Opcode( 0xCB2A, SRA, 8, "SRA %r0" ),
					new Opcode( 0xCB2B, SRA, 8, "SRA %r0" ),
					new Opcode( 0xCB2C, SRA, 8, "SRA %r0" ),
					new Opcode( 0xCB2D, SRA, 8, "SRA %r0" ),
					new Opcode( 0xCB2E, SRA, 15, "SRA (HL)" ),
					new Opcode( 0xCB2F, SRA, 8, "SRA %r0" ),		
					new Opcode( 0xCB30, SWAP, 8, "SWAP %r0" ),
					new Opcode( 0xCB31, SWAP, 8, "SWAP %r0" ),
					new Opcode( 0xCB32, SWAP, 8, "SWAP %r0" ),
					new Opcode( 0xCB33, SWAP, 8, "SWAP %r0" ),
					new Opcode( 0xCB34, SWAP, 8, "SWAP %r0" ),
					new Opcode( 0xCB35, SWAP, 8, "SWAP %r0" ),
					new Opcode( 0xCB36, SWAP, 15, "SWAP (HL)" ),
					new Opcode( 0xCB37, SWAP, 8, "SWAP %r0" ),	
					new Opcode( 0xCB38, SRL, 8, "SRL %r0" ),
					new Opcode( 0xCB39, SRL, 8, "SRL %r0" ),
					new Opcode( 0xCB3A, SRL, 8, "SRL %r0" ),
					new Opcode( 0xCB3B, SRL, 8, "SRL %r0" ),
					new Opcode( 0xCB3C, SRL, 8, "SRL %r0" ),
					new Opcode( 0xCB3D, SRL, 8, "SRL %r0" ),
					new Opcode( 0xCB3E, SRL, 15, "SRL (HL)" ),
					new Opcode( 0xCB3F, SRL, 8, "SRL %r0" ),		
					new Opcode( 0xCB40, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB41, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB42, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB43, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB44, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB45, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB46, BIT, 12, "BIT %b, (HL)" ),
					new Opcode( 0xCB47, BIT, 8, "BIT %b, %r0" ),		
					new Opcode( 0xCB48, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB49, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB4A, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB4B, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB4C, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB4D, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB4E, BIT, 12, "BIT %b, (HL)" ),
					new Opcode( 0xCB4F, BIT, 8, "BIT %b, %r0" ),		
					new Opcode( 0xCB50, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB51, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB52, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB53, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB54, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB55, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB56, BIT, 12, "BIT %b, (HL)" ),
					new Opcode( 0xCB57, BIT, 8, "BIT %b, %r0" ),		
					new Opcode( 0xCB58, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB59, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB5A, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB5B, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB5C, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB5D, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB5E, BIT, 12, "BIT %b, (HL)" ),
					new Opcode( 0xCB5F, BIT, 8, "BIT %b, %r0" ), 		
					new Opcode( 0xCB60, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB61, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB62, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB63, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB64, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB65, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB66, BIT, 12, "BIT %b, (HL)" ),
					new Opcode( 0xCB67, BIT, 8, "BIT %b, %r0" ),			
					new Opcode( 0xCB68, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB69, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB6A, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB6B, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB6C, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB6D, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB6E, BIT, 12, "BIT %b, (HL)" ),
					new Opcode( 0xCB6F, BIT, 8, "BIT %b, %r0" ),			
					new Opcode( 0xCB70, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB71, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB72, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB73, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB74, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB75, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB76, BIT, 12, "BIT %b, (HL)" ),
					new Opcode( 0xCB77, BIT, 8, "BIT %b, %r0" ),			
					new Opcode( 0xCB78, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB79, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB7A, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB7B, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB7C, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB7D, BIT, 8, "BIT %b, %r0" ),
					new Opcode( 0xCB7E, BIT, 12, "BIT %b, (HL)" ),
					new Opcode( 0xCB7F, BIT, 8, "BIT %b, %r0" ),			
					new Opcode( 0xCB80, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB81, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB82, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB83, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB84, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB85, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB86, RES, 15, "RES %b, (HL)" ),
					new Opcode( 0xCB87, RES, 8, "RES %b, %r0" ),			
					new Opcode( 0xCB88, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB89, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB8A, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB8B, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB8C, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB8D, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB8E, RES, 15, "RES %b, (HL)" ),
					new Opcode( 0xCB8F, RES, 8, "RES %b, %r0" ),			
					new Opcode( 0xCB90, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB91, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB92, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB93, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB94, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB95, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB96, RES, 15, "RES %b, (HL)" ),
					new Opcode( 0xCB97, RES, 8, "RES %b, %r0" ),			
					new Opcode( 0xCB98, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB99, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB9A, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB9B, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB9C, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB9D, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCB9E, RES, 15, "RES %b, (HL)" ),
					new Opcode( 0xCB9F, RES, 8, "RES %b, %r0" ),			
					new Opcode( 0xCBA0, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBA1, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBA2, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBA3, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBA4, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBA5, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBA6, RES, 15, "RES %b, (HL)" ),
					new Opcode( 0xCBA7, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBA8, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBA9, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBAA, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBAB, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBAC, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBAD, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBAE, RES, 15, "RES %b, (HL)" ),
					new Opcode( 0xCBAF, RES, 8, "RES %b, %r0" ),				
					new Opcode( 0xCBB0, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBB1, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBB2, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBB3, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBB4, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBB5, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBB6, RES, 15, "RES %b, (HL)" ),
					new Opcode( 0xCBB7, RES, 8, "RES %b, %r0" ),				
					new Opcode( 0xCBB8, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBB9, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBBA, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBBB, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBBC, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBBD, RES, 8, "RES %b, %r0" ),
					new Opcode( 0xCBBE, RES, 15, "RES %b, (HL)" ),
					new Opcode( 0xCBBF, RES, 8, "RES %b, %r0" ),				
					new Opcode( 0xCBC0, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBC1, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBC2, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBC3, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBC4, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBC5, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBC6, SET, 15, "SET %b, (HL)" ),
					new Opcode( 0xCBC7, SET, 8, "SET %b, %r0" ),				
					new Opcode( 0xCBC8, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBC9, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBCA, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBCB, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBCC, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBCD, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBCE, SET, 15, "SET %b, (HL)" ),
					new Opcode( 0xCBCF, SET, 8, "SET %b, %r0" ),				
					new Opcode( 0xCBD0, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBD1, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBD2, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBD3, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBD4, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBD5, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBD6, SET, 15, "SET %b, (HL)" ),
					new Opcode( 0xCBD7, SET, 8, "SET %b, %r0" ),	
					new Opcode( 0xCBD8, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBD9, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBDA, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBDB, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBDC, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBDD, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBDE, SET, 15, "SET %b, (HL)" ),
					new Opcode( 0xCBDF, SET, 8, "SET %b, %r0" ),				
					new Opcode( 0xCBE0, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBE1, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBE2, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBE3, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBE4, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBE5, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBE6, SET, 15, "SET %b, (HL)" ),
					new Opcode( 0xCBE7, SET, 8, "SET %b, %r0" ),				
					new Opcode( 0xCBE8, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBE9, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBEA, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBEB, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBEC, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBED, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBEE, SET, 15, "SET %b, (HL)" ),
					new Opcode( 0xCBEF, SET, 8, "SET %b, %r0" ),				
					new Opcode( 0xCBF0, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBF1, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBF2, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBF3, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBF4, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBF5, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBF6, SET, 15, "SET %b, (HL)" ),
					new Opcode( 0xCBF7, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBF8, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBF9, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBFA, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBFB, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBFC, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBFD, SET, 8, "SET %b, %r0" ),
					new Opcode( 0xCBFE, SET, 15, "SET %b, (HL)" ),
					new Opcode( 0xCBFF, SET, 8, "SET %b, %r0" ),
				};
				
			}
			
		}
		
	}
	
}
