﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
		
		public partial class VideoMemory : IVideoMemory
		{
		
			private class TileAttributes : ITileAttributes
			{
	
				public int Bank
				{
					get
					{
						return ( ( Value & 0x08 ) >> 3 );
					}
				}
								
				public bool FlippedHorizontally
				{
					get
					{
						return ( ( Value & 0x20 ) != 0 );
					}
				}
				
				public bool FlippedVertically
				{
					get
					{
						return ( ( Value & 0x40 ) != 0 );
					}
				}
				
				public int PaletteIndex
				{
					get
					{
						return ( Value & 0x07 );
					}
				}
				
				public int Priority
				{
					get
					{
						return ( Value >> 7 );
					}
				}
				
				private byte Value = 0;
				
				public TileAttributes( byte Value )
				{
					this.Value = Value;
					return;
				}
	
			}
				
		}
		
	}
	
}


