﻿using System;
using System.Runtime.InteropServices;
using Collections = System.Collections.Generic;
using GameKnight.Core;

using Framework = Microsoft.Xna.Framework;

namespace GameKnight.XNA
{

	public sealed class Timer : ITimer
	{

		private readonly Collections.Dictionary<object,double> ObjectList = new Collections.Dictionary<object,double>();
		
		public double TimePassed
		{
			get
			{
				return TimePassedProperty;
			}
			set
			{
				TimePassedProperty = value;
			}
		}
	
		private double TimePassedProperty = 0.0;
		
		public Timer()
		{
			Reset();
			return;
		}
				
		public double GetInterval( object Item )
		{
			if( ObjectList.ContainsKey( Item ) == false )
			{
				ObjectList.Add( Item, TimePassed );
			}	
			double Result = ( TimePassed - ObjectList[Item] );
			ObjectList[Item] = TimePassed;
			return Result;
		}

		public void Reset()
		{              
			ObjectList.Clear();
			TimePassed = 0.0;
			return;
		}
		
		public void Update( Framework.GameTime GameTime )
		{
			TimePassed += ( GameTime.ElapsedGameTime.Ticks / 10000000.0 );
			return;
		}

	}

}
